__gnu_debug::_Safe_local_iterator< _Iterator, _Sequence > Class Template Reference
Inheritance diagram for __gnu_debug::_Safe_local_iterator< _Iterator, _Sequence >:
[legend]

## Public Types

typedef _Traits::difference_type | difference_type
typedef _Traits::iterator_category | iterator_category
typedef _Iterator | iterator_type
typedef _Traits::pointer | pointer
typedef _Traits::reference | reference
typedef _Traits::value_type | value_type

## Public Member Functions

| _Safe_local_iterator () noexcept
| _Safe_local_iterator (const _Iterator &__i, const _Safe_sequence_base *__cont)
| _Safe_local_iterator (const _Safe_local_iterator &__x) noexcept
| _Safe_local_iterator (_Safe_local_iterator &&__x) noexcept
template<typename _MutableIterator >
| _Safe_local_iterator (const _Safe_local_iterator< _MutableIterator, typename __gnu_cxx::__enable_if< std::__are_same< _MutableIterator, typename _Sequence::local_iterator::iterator_type >::__value, _Sequence >::__type > &__x)
void | _M_attach (_Safe_sequence_base *__seq, bool __constant)
void | _M_attach (_Safe_sequence_base *__seq)
void | _M_attach_single (_Safe_sequence_base *__seq, bool __constant) throw ()
void | _M_attach_single (_Safe_sequence_base *__seq)
bool | _M_attached_to (const _Safe_sequence_base *__seq) const
bool | _M_can_compare (const _Safe_iterator_base &__x) const throw ()
bool | _M_dereferenceable () const
void | _M_detach ()
void | _M_detach_single () throw ()
__gnu_cxx::__conditional_type< std::__are_same< _Const_local_iterator, _Safe_local_iterator >::__value, const _Sequence *, _Sequence * >::__type | _M_get_sequence () const
template<typename _Other >
bool | _M_in_same_bucket (const _Safe_local_iterator< _Other, _Sequence > &__other) const
bool | _M_incrementable () const
void | _M_invalidate ()
bool | _M_is_begin () const
bool | _M_is_end () const
void | _M_reset () throw ()
bool | _M_singular () const throw ()
void | _M_unlink () throw ()
bool | _M_valid_range (const _Safe_local_iterator &__rhs, std::pair< difference_type, _Distance_precision > &__dist_info) const
_Iterator & | base () noexcept
const _Iterator & | base () const noexcept
size_type | bucket () const
| operator _Iterator () const
reference | operator* () const
_Safe_local_iterator & | operator++ ()
_Safe_local_iterator | operator++ (int)
pointer | operator-> () const
_Safe_local_iterator & | operator= (const _Safe_local_iterator &__x)
_Safe_local_iterator & | operator= (_Safe_local_iterator &&__x) noexcept

## Public Attributes

_Safe_iterator_base * | _M_next
_Safe_iterator_base * | _M_prior
_Safe_sequence_base * | _M_sequence
unsigned int | _M_version

## Protected Member Functions

_Safe_unordered_container_base * | _M_get_container () const noexcept
__gnu_cxx::__mutex & | _M_get_mutex () throw ()

## Detailed Description

### template<typename _Iterator, typename _Sequence>
class __gnu_debug::_Safe_local_iterator< _Iterator, _Sequence >

Safe iterator wrapper.

The class template _Safe_local_iterator is a wrapper around an iterator that tracks the iterator's movement among sequences and checks that operations performed on the "safe" iterator are legal. In additional to the basic iterator operations (which are validated, and then passed to the underlying iterator), _Safe_local_iterator has member functions for iterator invalidation, attaching/detaching the iterator from sequences, and querying the iterator's state.

Definition at line 59 of file formatter.h.

## Constructor & Destructor Documentation

## _Safe_local_iterator() [1/5]

template<typename _Iterator, typename _Sequence>

__gnu_debug::_Safe_local_iterator< _Iterator, _Sequence >::_Safe_local_iterator | ( |  | ) |

inline noexcept

Postcondition
  the iterator is singular and unattached

Definition at line 84 of file safe_local_iterator.h.

## _Safe_local_iterator() [2/5]

template<typename _Iterator, typename _Sequence>

__gnu_debug::_Safe_local_iterator< _Iterator, _Sequence >::_Safe_local_iterator | ( | const _Iterator & | __i,
|  | const _Safe_sequence_base * | __cont
| ) |  |

inline

Safe iterator construction from an unsafe iterator and its sequence.

Precondition
  `seq` is not NULL

Postcondition
  this is not singular

Definition at line 93 of file safe_local_iterator.h.

## _Safe_local_iterator() [3/5]

template<typename _Iterator, typename _Sequence>

__gnu_debug::_Safe_local_iterator< _Iterator, _Sequence >::_Safe_local_iterator | ( | const _Safe_local_iterator< _Iterator, _Sequence > & | __x | ) |

inline noexcept

Copy construction.

Definition at line 105 of file safe_local_iterator.h.

## _Safe_local_iterator() [4/5]

template<typename _Iterator, typename _Sequence>

__gnu_debug::_Safe_local_iterator< _Iterator, _Sequence >::_Safe_local_iterator | ( | _Safe_local_iterator< _Iterator, _Sequence > && | __x | ) |

inline noexcept

Move construction.

Postcondition
  __x is singular and unattached

Definition at line 122 of file safe_local_iterator.h.

## _Safe_local_iterator() [5/5]

template<typename _Iterator, typename _Sequence>
template<typename _MutableIterator >

__gnu_debug::_Safe_local_iterator< _Iterator, _Sequence >::_Safe_local_iterator | ( | const _Safe_local_iterator< _MutableIterator, typename __gnu_cxx::__enable_if< std::__are_same< _MutableIterator, typename _Sequence::local_iterator::iterator_type >::__value, _Sequence >::__type > & | __x | ) |

inline

Converting constructor from a mutable iterator to a constant iterator.

Definition at line 141 of file safe_local_iterator.h.

## Member Function Documentation

## _M_attach() [1/2]

void __gnu_debug::_Safe_local_iterator_base::_M_attach | ( | _Safe_sequence_base * | __seq,
|  | bool | __constant
| ) |  |

inherited

Attaches this iterator to the given container, detaching it from whatever container it was attached to originally. If the new container is the NULL pointer, the iterator is left unattached.

Referenced by __gnu_debug::_Safe_local_iterator< _Iterator, _Sequence >::_M_attach(), and __gnu_debug::_Safe_local_iterator_base::_Safe_local_iterator_base().

## _M_attach() [2/2]

template<typename _Iterator, typename _Sequence>

void __gnu_debug::_Safe_local_iterator< _Iterator, _Sequence >::_M_attach | ( | _Safe_sequence_base * | __seq | ) |

inline

Attach iterator to the given sequence.

Definition at line 305 of file safe_local_iterator.h.

References __gnu_debug::_Safe_local_iterator_base::_M_attach().

## _M_attach_single() [1/2]

void __gnu_debug::_Safe_local_iterator_base::_M_attach_single | ( | _Safe_sequence_base * | __seq,
|  | bool | __constant
| ) |  |
throw | ( |
| ) |  |

inherited

Likewise, but not thread-safe.

Referenced by __gnu_debug::_Safe_local_iterator< _Iterator, _Sequence >::_M_attach_single(), and __gnu_debug::_Safe_local_iterator_base::_Safe_local_iterator_base().

## _M_attach_single() [2/2]

template<typename _Iterator, typename _Sequence>

void __gnu_debug::_Safe_local_iterator< _Iterator, _Sequence >::_M_attach_single | ( | _Safe_sequence_base * | __seq | ) |

inline

Likewise, but not thread-safe.

Definition at line 310 of file safe_local_iterator.h.

References __gnu_debug::_Safe_local_iterator_base::_M_attach_single().

## _M_attached_to()

bool __gnu_debug::_Safe_iterator_base::_M_attached_to | ( | const _Safe_sequence_base * | __seq | ) | const

inline inherited

Determines if we are attached to the given sequence.

Definition at line 129 of file safe_base.h.

References __gnu_debug::_Safe_iterator_base::_M_can_compare(), and __gnu_debug::_Safe_iterator_base::_M_singular().

## _M_can_compare()

bool __gnu_debug::_Safe_iterator_base::_M_can_compare | ( | const _Safe_iterator_base & | __x | ) | const
throw | ( |
| ) |  |

inherited

Can we compare this iterator to the given iterator `__x`? Returns true if both iterators are nonsingular and reference the same sequence.

Referenced by __gnu_debug::_Safe_iterator_base::_M_attached_to().

## _M_dereferenceable()

template<typename _Iterator, typename _Sequence>

bool __gnu_debug::_Safe_local_iterator< _Iterator, _Sequence >::_M_dereferenceable | ( |  | ) | const

inline

Is the iterator dereferenceable?

Definition at line 315 of file safe_local_iterator.h.

References __gnu_debug::_Safe_local_iterator< _Iterator, _Sequence >::_M_is_end(), and __gnu_debug::_Safe_iterator_base::_M_singular().

## _M_detach()

void __gnu_debug::_Safe_local_iterator_base::_M_detach | ( |  | ) |

inherited

Detach the iterator for whatever container it is attached to, if any.

Referenced by __gnu_debug::_Safe_local_iterator_base::_Safe_local_iterator_base().

## _M_detach_single()

void __gnu_debug::_Safe_local_iterator_base::_M_detach_single | ( |  | ) |
throw | ( |
| ) |  |

inherited

Likewise, but not thread-safe.

Referenced by __gnu_debug::_Safe_local_iterator_base::_Safe_local_iterator_base().

## _M_get_mutex()

__gnu_cxx::__mutex& __gnu_debug::_Safe_iterator_base::_M_get_mutex | ( |  | ) |
throw | ( |
| ) |  |

protected inherited

For use in _Safe_iterator.

Referenced by __gnu_debug::_Safe_iterator_base::_Safe_iterator_base(), and __gnu_debug::_Safe_sequence_base::~_Safe_sequence_base().

## _M_in_same_bucket()

template<typename _Iterator, typename _Sequence>
template<typename _Other >

bool __gnu_debug::_Safe_local_iterator< _Iterator, _Sequence >::_M_in_same_bucket | ( | const _Safe_local_iterator< _Other, _Sequence > & | __other | ) | const

inline

Is this iterator part of the same bucket as the other one?

Definition at line 349 of file safe_local_iterator.h.

References __gnu_debug::_Safe_local_iterator< _Iterator, _Sequence >::bucket().

## _M_incrementable()

template<typename _Iterator, typename _Sequence>

bool __gnu_debug::_Safe_local_iterator< _Iterator, _Sequence >::_M_incrementable | ( |  | ) | const

inline

Is the iterator incrementable?

Definition at line 320 of file safe_local_iterator.h.

References __gnu_debug::_Safe_local_iterator< _Iterator, _Sequence >::_M_is_end(), __gnu_debug::_Safe_iterator_base::_M_sequence, and __gnu_debug::_Safe_iterator_base::_M_singular().

## _M_invalidate()

void __gnu_debug::_Safe_iterator_base::_M_invalidate | ( |  | ) |

inline inherited

Invalidate the iterator, making it singular.

Definition at line 144 of file safe_base.h.

References __gnu_debug::_Safe_iterator_base::_M_reset().

## _M_is_begin()

template<typename _Iterator, typename _Sequence>

bool __gnu_debug::_Safe_local_iterator< _Iterator, _Sequence >::_M_is_begin | ( |  | ) | const

inline

Is this iterator equal to the sequence's begin(bucket) iterator?

Definition at line 339 of file safe_local_iterator.h.

References __gnu_debug::_Safe_local_iterator< _Iterator, _Sequence >::base(), and __gnu_debug::_Safe_local_iterator< _Iterator, _Sequence >::bucket().

## _M_is_end()

template<typename _Iterator, typename _Sequence>

bool __gnu_debug::_Safe_local_iterator< _Iterator, _Sequence >::_M_is_end | ( |  | ) | const

inline

Is this iterator equal to the sequence's end(bucket) iterator?

Definition at line 343 of file safe_local_iterator.h.

References __gnu_debug::_Safe_local_iterator< _Iterator, _Sequence >::base(), and __gnu_debug::_Safe_local_iterator< _Iterator, _Sequence >::bucket().

Referenced by __gnu_debug::_Safe_local_iterator< _Iterator, _Sequence >::_M_dereferenceable(), and __gnu_debug::_Safe_local_iterator< _Iterator, _Sequence >::_M_incrementable().

## _M_reset()

void __gnu_debug::_Safe_iterator_base::_M_reset | ( |  | ) |
throw | ( |
| ) |  |

inherited

Reset all member variables

Referenced by __gnu_debug::_Safe_iterator_base::_M_invalidate().

## _M_singular()

bool __gnu_debug::_Safe_iterator_base::_M_singular | ( |  | ) | const
throw | ( |
| ) |  |

inherited

Is this iterator singular?

Referenced by __gnu_debug::__check_singular_aux(), __gnu_debug::_Safe_iterator_base::_M_attached_to(), __gnu_debug::_Safe_local_iterator< _Iterator, _Sequence >::_M_dereferenceable(), and __gnu_debug::_Safe_local_iterator< _Iterator, _Sequence >::_M_incrementable().

## _M_unlink()

void __gnu_debug::_Safe_iterator_base::_M_unlink | ( |  | ) |
throw | ( |
| ) |  |

inline inherited

Unlink itself

Definition at line 153 of file safe_base.h.

## base()

template<typename _Iterator, typename _Sequence>

_Iterator& __gnu_debug::_Safe_local_iterator< _Iterator, _Sequence >::base | ( |  | ) |

inline noexcept

Return the underlying iterator.

Definition at line 286 of file safe_local_iterator.h.

Referenced by __gnu_debug::_Safe_local_iterator< _Iterator, _Sequence >::_M_is_begin(), __gnu_debug::_Safe_local_iterator< _Iterator, _Sequence >::_M_is_end(), and __gnu_debug::_Safe_local_iterator< _Iterator, _Sequence >::bucket().

## bucket()

template<typename _Iterator, typename _Sequence>

size_type __gnu_debug::_Safe_local_iterator< _Iterator, _Sequence >::bucket | ( |  | ) | const

inline

Return the bucket.

Definition at line 295 of file safe_local_iterator.h.

References __gnu_debug::_Safe_local_iterator< _Iterator, _Sequence >::base().

Referenced by __gnu_debug::_Safe_local_iterator< _Iterator, _Sequence >::_M_in_same_bucket(), __gnu_debug::_Safe_local_iterator< _Iterator, _Sequence >::_M_is_begin(), and __gnu_debug::_Safe_local_iterator< _Iterator, _Sequence >::_M_is_end().

## operator _Iterator()

template<typename _Iterator, typename _Sequence>

__gnu_debug::_Safe_local_iterator< _Iterator, _Sequence >::operator _Iterator | ( |  | ) | const

inline

Conversion to underlying non-debug iterator to allow better interaction with non-debug containers.

Definition at line 301 of file safe_local_iterator.h.

## operator*()

template<typename _Iterator, typename _Sequence>

reference __gnu_debug::_Safe_local_iterator< _Iterator, _Sequence >::operator* | ( |  | ) | const

inline

Iterator dereference.

Precondition
  iterator is dereferenceable

Definition at line 228 of file safe_local_iterator.h.

## operator++() [1/2]

template<typename _Iterator, typename _Sequence>

_Safe_local_iterator& __gnu_debug::_Safe_local_iterator< _Iterator, _Sequence >::operator++ | ( |  | ) |

inline

Iterator preincrement.

Precondition
  iterator is incrementable

Definition at line 256 of file safe_local_iterator.h.

## operator++() [2/2]

template<typename _Iterator, typename _Sequence>

_Safe_local_iterator __gnu_debug::_Safe_local_iterator< _Iterator, _Sequence >::operator++ | ( | int |  | ) |

inline

Iterator postincrement.

Precondition
  iterator is incrementable

Definition at line 271 of file safe_local_iterator.h.

## operator->()

template<typename _Iterator, typename _Sequence>

pointer __gnu_debug::_Safe_local_iterator< _Iterator, _Sequence >::operator-> | ( |  | ) | const

inline

Iterator dereference.

Precondition
  iterator is dereferenceable

Todo:
  Make this correct w.r.t. iterators that return proxies

Definition at line 242 of file safe_local_iterator.h.

## operator=() [1/2]

template<typename _Iterator, typename _Sequence>

_Safe_local_iterator& __gnu_debug::_Safe_local_iterator< _Iterator, _Sequence >::operator= | ( | const _Safe_local_iterator< _Iterator, _Sequence > & | __x | ) |

inline

Copy assignment.

Definition at line 163 of file safe_local_iterator.h.

## operator=() [2/2]

template<typename _Iterator, typename _Sequence>

_Safe_local_iterator& __gnu_debug::_Safe_local_iterator< _Iterator, _Sequence >::operator= | ( | _Safe_local_iterator< _Iterator, _Sequence > && | __x | ) |

inline noexcept

Move assignment.

Postcondition
  __x is singular and unattached

Definition at line 194 of file safe_local_iterator.h.

## Member Data Documentation

## _M_next

_Safe_iterator_base* __gnu_debug::_Safe_iterator_base::_M_next

inherited

Pointer to the next iterator in the sequence's list of iterators. Only valid when _M_sequence != NULL.

Definition at line 72 of file safe_base.h.

Referenced by __gnu_debug::_Safe_sequence< map< _Key, _Tp, _Compare, _Allocator > >::_M_transfer_from_if().

## _M_prior

_Safe_iterator_base* __gnu_debug::_Safe_iterator_base::_M_prior

inherited

Pointer to the previous iterator in the sequence's list of iterators. Only valid when _M_sequence != NULL.

Definition at line 68 of file safe_base.h.

Referenced by __gnu_debug::_Safe_sequence< map< _Key, _Tp, _Compare, _Allocator > >::_M_transfer_from_if().

## _M_sequence

_Safe_sequence_base* __gnu_debug::_Safe_iterator_base::_M_sequence

inherited

The sequence this iterator references; may be NULL to indicate a singular iterator.

Definition at line 55 of file safe_base.h.

Referenced by __gnu_debug::_Safe_local_iterator< _Iterator, _Sequence >::_M_incrementable(), __gnu_debug::_Safe_sequence< map< _Key, _Tp, _Compare, _Allocator > >::_M_transfer_from_if(), __gnu_debug::_Safe_iterator_base::_Safe_iterator_base(), and __gnu_debug::_Safe_local_iterator_base::_Safe_local_iterator_base().

## _M_version

unsigned int __gnu_debug::_Safe_iterator_base::_M_version

inherited

The version number of this iterator. The sentinel value 0 is used to indicate an invalidated iterator (i.e., one that is singular because of an operation on the container). This version number must equal the version number in the sequence referenced by _M_sequence for the iterator to be non-singular.

Definition at line 64 of file safe_base.h.

Referenced by __gnu_debug::_Safe_sequence< map< _Key, _Tp, _Compare, _Allocator > >::_M_transfer_from_if().

The documentation for this class was generated from the following files:

- formatter.h
- safe_local_iterator.h
- safe_local_iterator.tcc